## deepin-anything 5.0.18

=== Makefile ===
VERSION := 0.0
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

all:
	sed 's|@@VERSION@@|$(VERSION)|g' debian/deepin-anything-dkms.dkms.in | tee debian/deepin-anything-dkms.dkms
	make -C library all
	cd server && qmake -makefile -nocache QMAKE_STRIP=: PREFIX=/usr LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) deepin-anything-server.pro && make all

install:
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	cp library/bin/release/* $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	mkdir -p $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
	cp -r kernelmod/* $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
	mkdir -p $(DESTDIR)/usr/lib/modules-load.d
	echo "" | tee $(DESTDIR)/usr/lib/modules-load.d/anything.conf
	mkdir -p $(DESTDIR)/usr/include/deepin-anything
	cp -r library/inc/* $(DESTDIR)/usr/include/deepin-anything
	cp -r kernelmod/vfs_change_uapi.h $(DESTDIR)/usr/include/deepin-anything
	cp -r kernelmod/vfs_change_consts.h $(DESTDIR)/usr/include/deepin-anything
	make -C server install INSTALL_ROOT=$(DESTDIR)

clean:
	rm -f debian/deepin-anything-dkms.dkms
	make -C library clean
	@[ -f server/Makefile ] && make -C server distclean || true

=== cli/Makefile ===
CFLAGS := -std=gnu99 -Wall -I../library/inc -I../library/inc/index -I../kernelmod -Iinc
LDFLAG := -lpthread -lanything

all: release debug

release: bin/release/anything_cli

bin/release/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../library/bin/release/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -O3 $^ -o $@ ${LDFLAG}

debug: bin/debug/anything_cli

bin/debug/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../library/bin/debug/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -DIDX_DEBUG -g $^ -o $@ ${LDFLAG}

clean:
	rm -Rf bin

.PHONY: all release debug clean

=== kernelmod/Makefile ===
obj-m += vfs_monitor.o
vfs_monitor-objs := vfs_utils.o arg_extractor.o vfs_change.o vfs_kretprobes.o
ccflags-y := -std=gnu99 -Wno-declaration-after-statement -O3
cwd := $(shell pwd)

kdir := /lib/modules/$(shell uname -r)/build

all:
	make -C ${kdir} M=$(cwd) modules

clean:
	make -C ${kdir} M=$(cwd) clean

=== library/Makefile ===
CC := gcc
GLIB_INCL := $(shell pkg-config --cflags glib-2.0)
GLIB_LIB := $(shell pkg-config --libs glib-2.0)
CFLAGS := -std=gnu99 -Wall -Wl,--no-undefined -D_GNU_SOURCE -Iinc -Iinc/index ${GLIB_INCL} -shared -fPIC -fvisibility=hidden
LDFLAG := -lpthread -lpcre ${GLIB_LIB}

all: release debug

release: bin/release/libanything.so

bin/release/libanything.so: src/*.c src/index/*.c src/chinese/*.c
	mkdir -p bin/release
	rm bin/release/*.so*||true
	$(CC) $(CFLAGS) -O3 -Wl,-soname,$(shell basename $@).1.0.0 $^ -o $@.1.0.0 $(LDFLAG)
	ln -s $(shell basename $@).1.0.0 $@.1.0
	ln -s $(shell basename $@).1.0.0 $@.1
	ln -s $(shell basename $@).1.0.0 $@

debug: bin/debug/libanything.so

bin/debug/libanything.so: src/*.c src/index/*.c src/chinese/*.c
	mkdir -p bin/debug
	rm bin/debug/*.so*||true
	$(CC) $(CFLAGS) -g -DIDX_DEBUG -Wl,-soname,$(shell basename $@).1.0.0 $^ -o $@.1.0.0 $(LDFLAG)
	ln -s $(shell basename $@).1.0.0 $@.1.0
	ln -s $(shell basename $@).1.0.0 $@.1
	ln -s $(shell basename $@).1.0.0 $@

clean:
	-rm -rf bin

.PHONY: all release debug clean

=== debian/changelog ===
deepin-anything (5.0.18-1) unstable; urgency=medium

  * update

 -- Deepin Package Builder <packages@deepin.com>  Thu, 17 Mar 2022 14:16:41 +0800

deepin-anything (20180315+1) unstable; urgency=medium

  * Initial release.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 20 Mar 2018 11:46:47 +0800

=== debian/control ===
Source: deepin-anything
Section: admin
Priority: optional
Maintainer: Deepin Package Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), dkms, dh-systemd, qtbase5-dev,
 pkg-config, libudisks2-qt5-dev, libmount-dev, libdtkcore-dev, libglib2.0-dev
Standards-Version: 3.9.8
Homepage: http://github.com/linuxdeepin/deepin-anything

Package: deepin-anything-libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: anything library
 anything library package

Package: deepin-anything-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 deepin-anything-libs( =${binary:Version}),
Description: anything user interface library
 anything library developer package.

Package: deepin-anything-dkms
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
Description: anything module
 anything kernel module package

Package: deepin-anything-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, deepin-anything-dkms
Description: anything server application and lib
 anything server package

Package: deepin-anything-server-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 deepin-anything-server( =${binary:Version}),
Description: anything server user interface library
 anything server library developer package.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

%:
	dh $@ --with dkms,systemd

override_dh_installinit:
	true

## deepin-anything 6.0.3

=== src/Makefile ===
VERSION := 0.0
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

all:
	sed 's|@@VERSION@@|$(VERSION)|g' ../debian/deepin-anything-dkms.dkms.in | tee ../debian/deepin-anything-dkms.dkms
	make -C library all
	cd server && qmake -makefile -nocache QMAKE_STRIP=: PREFIX=/usr LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) deepin-anything-backend.pro && make all

install:
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	cp library/bin/release/* $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	mkdir -p $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
	cp -r kernelmod/* $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
	mkdir -p $(DESTDIR)/usr/lib/modules-load.d
	echo "" | tee $(DESTDIR)/usr/lib/modules-load.d/anything.conf
	mkdir -p $(DESTDIR)/usr/include/deepin-anything
	cp -r library/inc/* $(DESTDIR)/usr/include/deepin-anything
	cp -r kernelmod/vfs_genl.h $(DESTDIR)/usr/include/deepin-anything
	cp -r kernelmod/vfs_change_consts.h $(DESTDIR)/usr/include/deepin-anything
	make -C server install INSTALL_ROOT=$(DESTDIR)

clean:
	rm -f ../debian/deepin-anything-dkms.dkms
	make -C library clean
	@[ -f server/Makefile ] && make -C server distclean || true

=== src/cli/Makefile ===
CFLAGS := -std=gnu99 -Wall -I../src/library/inc -I../src/library/inc/index -I../kernelmod -Iinc
LDFLAG := -lpthread -lanything

all: release debug

release: bin/release/anything_cli

bin/release/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../src/library/bin/release/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -O3 $^ -o $@ ${LDFLAG}

debug: bin/debug/anything_cli

bin/debug/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../src/library/bin/debug/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -DIDX_DEBUG -g $^ -o $@ ${LDFLAG}

clean:
	rm -Rf bin

.PHONY: all release debug clean

=== src/kernelmod/Makefile ===
obj-m += vfs_monitor.o
vfs_monitor-objs := arg_extractor.o event_merge.o event.o module.o \
		    vfs_kretprobes.o vfs_fsnotify.o vfs_genl.o
ccflags-y := -std=gnu99 -Wall -O3
cwd := $(shell pwd)

kdir := /lib/modules/$(shell uname -r)/build

all:
	make -C ${kdir} M=$(cwd) modules

clean:
	make -C ${kdir} M=$(cwd) clean

=== src/library/Makefile ===
CC := gcc
GLIB_INCL := $(shell pkg-config --cflags glib-2.0)
GLIB_LIB := $(shell pkg-config --libs glib-2.0)
CFLAGS := -std=gnu99 -Wall -Wl,--no-undefined -D_GNU_SOURCE -Iinc -Iinc/index -I../../3rdparty/fsearch ${GLIB_INCL} -shared -fPIC -fvisibility=hidden
LDFLAG := -lpthread -lpcre ${GLIB_LIB}

all: release debug

release: bin/release/libanything.so

bin/release/libanything.so: src/*.c src/index/*.c src/chinese/*.c ../../3rdparty/fsearch/*.c
	mkdir -p bin/release
	rm bin/release/*.so*||true
	$(CC) $(CFLAGS) -O3 -Wl,-soname,$(shell basename $@).1.0.0 $^ -o $@.1.0.0 $(LDFLAG)
	ln -s $(shell basename $@).1.0.0 $@.1.0
	ln -s $(shell basename $@).1.0.0 $@.1
	ln -s $(shell basename $@).1.0.0 $@

debug: bin/debug/libanything.so

bin/debug/libanything.so: src/*.c src/index/*.c src/chinese/*.c ../../3rdparty/fsearch/*.c
	mkdir -p bin/debug
	rm bin/debug/*.so*||true
	$(CC) $(CFLAGS) -g -DIDX_DEBUG -Wl,-soname,$(shell basename $@).1.0.0 $^ -o $@.1.0.0 $(LDFLAG)
	ln -s $(shell basename $@).1.0.0 $@.1.0
	ln -s $(shell basename $@).1.0.0 $@.1
	ln -s $(shell basename $@).1.0.0 $@

clean:
	-rm -rf bin

.PHONY: all release debug clean

=== debian/changelog ===
deepin-anything (6.0.3-1) unstable; urgency=medium

  * update

 -- Deepin Package Builder <packages@deepin.com>  Thu, 10 Nov 2022 09:18:47 +0800

deepin-anything (6.0.2) unstable; urgency=medium

  * rework deepin-anything-server

 -- Deepin Package Builder <packages@deepin.com>  Thu, 21 Jul 2022 15:52:06 +0800

deepin-anything (6.0.1-1) unstable; urgency=medium

  * Export entry function and change library name back for old dfm; The backend running with single instance.

 -- Deepin Package Builder <packages@deepin.com>  Mon, 25 Apr 2022 15:50:45 +0800

deepin-anything (6.0.0-1) unstable; urgency=medium

  * new version for tool and monitor are merged then release library, which will start as plugin in dde-file-manager-daemon.

 -- Deepin Package Builder <packages@deepin.com>  Mon, 18 Apr 2022 01:26:45 +0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Deepin Package Builder <packages@deepin.com>
-Build-Depends: debhelper (>= 9), dkms, dh-systemd, qtbase5-dev,
- pkg-config, libudisks2-qt5-dev, libmount-dev, libdtkcore-dev, libglib2.0-dev
+Build-Depends: debhelper (>= 9), dkms, qtbase5-dev,
+ pkg-config, libudisks2-qt5-dev, libmount-dev, libdtkcore-dev,
+ libglib2.0-dev, libpcre3-dev, libnl-genl-3-dev
 Standards-Version: 3.9.8
 Homepage: http://github.com/linuxdeepin/deepin-anything

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

%:
	dh $@ --with dkms

override_dh_installinit:
	true

## deepin-anything 6.1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(deepin-anything)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

add_subdirectory(${PROJECT_SOURCE_DIR}/src)

=== src/CMakeLists.txt ===

if(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

message("Build type:"${CMAKE_BUILD_TYPE})

add_subdirectory("library")
add_subdirectory("server")
add_subdirectory("kernelmod")

# add_subdirectory("cli")

=== src/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 install:
 	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
-	cp library/bin/release/* $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
+	make -C library install INSTALL_DIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
 	mkdir -p $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
 	cp -r kernelmod/* $(DESTDIR)/usr/src/deepin-anything-$(VERSION)
 	mkdir -p $(DESTDIR)/usr/lib/modules-load.d

=== src/kernelmod/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(vfs_monitor)

# Version
if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "0.0")
endif()

set(package_name "deepin-anything-${PROJECT_VERSION}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -O3")

 # Set the source files
# set(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*)

FILE(GLOB SOURCES
    "*.h"
    "*.c"
    )

FILE(GLOB SRC_FILES
    "*.h"
    "*.c"
    "Makefile"
    "CMakeLists.txt"
    )

 # Set the install directory
set(INSTALL_DIR /usr/src/${package_name})

 # Create the module target
# add_library(${PROJECT_NAME} SHARED ${SOURCES})

 # Set the install target
# install(TARGETS ${PROJECT_NAME} DESTINATION ${INSTALL_DIR})

# file(COPY kernelmod/* DESTINATION ${CMAKE_INSTALL_LIBDIR}/usr/src/deepin-anything-${VERSION})

 # Create the DKMS configuration file
configure_file(dkms.conf.in dkms.conf @ONLY)

 # Install the DKMS configuration file
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf DESTINATION ${INSTALL_DIR})

 # Create the DKMS deb package install file
configure_file(
    deepin-anything-dkms.dkms.in
    deepin-anything-dkms.dkms
    @ONLY
)

message("CMAKE_CURRENT_BINARY_DIR:" ${CMAKE_CURRENT_BINARY_DIR})

 # Install the DKMS file into debian dir
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-anything-dkms.dkms DESTINATION ../..)

 # Install all source files
 install(FILES ${SRC_FILES} DESTINATION ${INSTALL_DIR})

  # Install the module conf file
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/anything.conf DESTINATION /usr/lib/modules-load.d)

=== src/library/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(anything)

# Version
if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 0)
endif()

# Setup the environment
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(LIBPCRE REQUIRED libpcre)

set(3RD_DIR "../../3rdparty")

FILE(GLOB SRC_FILES
    "src/*.c"
    "src/index/*.c"
    "src/chinese/*.c"
    "${3RD_DIR}/fsearch/*.c"
)


# Build
add_library(${PROJECT_NAME} SHARED
    ${SRC_FILES}
)

set_target_properties(
    ${PROJECT_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

target_link_libraries(
    ${PROJECT_NAME}
    ${GLIB_LIBRARIES}
    ${LIBPCRE_LIBRARIES}
)

target_include_directories(
    ${PROJECT_NAME}
PUBLIC
    ${GLIB_INCLUDE_DIRS}
    ${LIBPCRE_INCLUDE_DIRS}
    ${CMAKE_CURRENT_LIST_DIR}/inc
    ${CMAKE_CURRENT_LIST_DIR}/inc/index
    ${3RD_DIR}/fsearch
)

include(GNUInstallDirs)
install(DIRECTORY
    ${PROJECT_SOURCE_DIR}/inc/
    DESTINATION include/deepin-anything
    FILES_MATCHING PATTERN "*.h"
)

install_targets ("/${CMAKE_INSTALL_LIBDIR}" ${PROJECT_NAME})

=== src/server/CMakeLists.txt ===
project(deepin-anything-server-lib)

cmake_minimum_required(VERSION 3.1.0)

# Setup the environment
SET(CMAKE_CXX_STANDARD 17)

# Must set automoc, or some unused symbols will be excluded.
SET(CMAKE_AUTOMOC ON)

SET(CMAKE_INCLUDE_CURRENT_DIR ON)

# set default build type
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif(NOT CMAKE_BUILD_TYPE)

add_subdirectory("backend")
add_subdirectory("app")

=== src/server/app/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(deepin-anything-server)

# Version
if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 0)
endif()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/../backend
)

set(SRCS
    main.cpp
)

find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS Core REQUIRED)

add_executable(${PROJECT_NAME} ${SRCS})

target_link_libraries(${PROJECT_NAME} PUBLIC
    Qt5::Core
    deepin-anything-server-lib
)

# binary
install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== src/server/backend/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

# Version
if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 0)
endif()

add_definitions(-DQT_MESSAGELOGCONTEXT)

if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
   add_definitions(-DDEFAULT_MSG_TYPE=QtDebugMsg)
#    SET(CMAKE_CXX_FLAGS_DEBUG "$ENV{CXXFLAGS} -O0 -Wall -g2 -ggdb")
else()
    # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
    add_definitions(-DDEFAULT_MSG_TYPE=QtWarningMsg)
    # SET(CMAKE_CXX_FLAGS_RELEASE "$ENV{CXXFLAGS} -O3 -Wall")
endif()

set(LFTManager_XML ${CMAKE_CURRENT_SOURCE_DIR}/dbusservice/com.deepin.anything.xml)

# Setup the environment
find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS DBus REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)
pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)

pkg_check_modules(qt-udisks2 REQUIRED udisks2-qt5 IMPORTED_TARGET)

# generate dbus interface
# DBus: LFTManager
# qt5_generate_dbus_interface(
#     lftmanager.h
#     ${DeviceManager_XML}
#     OPTIONS -M -S
# )
qt5_add_dbus_adaptor(SRCS ${LFTManager_XML}
    lftmanager.h LFTManager anything_adaptor)

# include
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/../../kernelmod
    ${CMAKE_CURRENT_SOURCE_DIR}/../../library/inc
    ${CMAKE_CURRENT_SOURCE_DIR}/lib
    ${CMAKE_CURRENT_SOURCE_DIR}/dbusservice
)

# private include
FILE (GLOB PRIVATE_INCLUDES
    "lib/*.h" "*.h"
)

# src
FILE (GLOB SERVER_SRCS
    "lib/*.cpp" "*.cpp"
)

# Build
add_library(${PROJECT_NAME} SHARED
    ${PRIVATE_INCLUDES}
    ${SERVER_SRCS}
    ${SRCS}
)

set_target_properties(
    ${PROJECT_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

target_link_libraries(${PROJECT_NAME} PUBLIC
    Qt5::Core
    Qt5::Concurrent
    Qt5::DBus
    PkgConfig::qt-udisks2
    anything
    ${MOUNT_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${GNL_LIBRARIES}
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ${GLIB_INCLUDE_DIRS}
    ${MOUNT_INCLUDE_DIRS}
    ${GNL_INCLUDE_DIRS}
    ${CMAKE_CURRENT_LIST_DIR}/lib
)

FILE (GLOB PUB_INCLUDES_INSTALL
    "anythingexport.h"
    "lib/lftmanager.h"
)
FILE (GLOB DBUS_INSTALL
    "dbusservice/com.deepin.anything.xml"
)
FILE (GLOB DBUS_CONFIG_INSTALL
    "dbusservice/com.deepin.anything.conf"
)

include(GNUInstallDirs)

install (FILES ${PUB_INCLUDES_INSTALL}
    DESTINATION include/${PROJECT_NAME}
)
install (FILES ${DBUS_INSTALL}
    DESTINATION /usr/share/dbus-1/interfaces
)
install (FILES ${DBUS_CONFIG_INSTALL}
    DESTINATION /etc/dbus-1/system.d
)

install_targets ("/${CMAKE_INSTALL_LIBDIR}" ${PROJECT_NAME})


configure_file ("${PROJECT_NAME}.pc.in" "${PROJECT_NAME}.pc" @ONLY)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== debian/changelog ===
deepin-anything (6.1.6) unstable; urgency=medium

  * update CMakeLists.

 -- Deepin Package Builder <packages@deepin.com>  Thu, 30 Nov 2023 14:48:21 +0800

deepin-anything (6.1.5) unstable; urgency=medium

  * add executable for running anything.
  * let process abort when cpu usage limit is exceeded.

 -- Deepin Package Builder <packages@deepin.com>  Thu, 26 Oct 2023 14:35:37 +0800

deepin-anything (6.1.4) unstable; urgency=medium

  * fix index issue.

 -- Deepin Package Builder <packages@deepin.com>  Wed, 19 Jul 2023 15:00:18 +0800

deepin-anything (6.1.3) unstable; urgency=medium

  * add miss build depend cmake.

 -- Deepin Package Builder <packages@deepin.com>  Mon, 03 Jul 2023 15:58:18 +0800

deepin-anything (6.1.2) unstable; urgency=medium

  * fix kernel module build issue for linux > 5.10.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 20 Jun 2023 16:50:58 +0800

deepin-anything (6.1.1) unstable; urgency=medium

  * fix can search issue for first start.
  * fix dgb install issue.
  * cmake build support.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 20 Jun 2023 16:32:58 +0800

deepin-anything (6.1.0) unstable; urgency=medium

  * fix dkms install issue.
  * fix dir name is 0 on loongson64.
  * fix BUG warning issue.

 -- Deepin Package Builder <packages@deepin.com>  Wed, 07 Jun 2023 17:30:58 +0800

deepin-anything (6.0.9) unstable; urgency=medium

  * fix miss libcgroup depending.

 -- Deepin Package Builder <packages@deepin.com>  Wed, 31 May 2023 16:30:58 +0800

deepin-anything (6.0.8) unstable; urgency=medium

  * add cpu resource usage limit.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 30 May 2023 16:07:58 +0800

deepin-anything (6.0.7) unstable; urgency=medium

  * update archlinux and rpm building package.
  * Fix the expired log issue.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 25 Apr 2023 15:40:51 +0800

deepin-anything (6.0.6) unstable; urgency=medium

  * Optimize the mount info and fix QStorageInfo block issue.

 -- Deepin Package Builder <packages@deepin.com>  Wed, 19 Apr 2023 17:04:15 +0800

deepin-anything (6.0.5) unstable; urgency=medium

  * Optimize the structure replace dbus with callback.

 -- Deepin Package Builder <packages@deepin.com>  Wed, 12 Apr 2023 17:04:15 +0800

deepin-anything (6.0.4) unstable; urgency=medium

  * fix search issue on dlnfs dir.

 -- Deepin Package Builder <packages@deepin.com>  Thu, 30 Mar 2023 03:04:15 +0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Deepin Package Builder <packages@deepin.com>
-Build-Depends: debhelper (>= 9), dkms, qtbase5-dev,
- pkg-config, libudisks2-qt5-dev, libmount-dev, libdtkcore-dev,
+Build-Depends:
+ cmake,
+ debhelper (>= 9), dh-dkms | dkms, qtbase5-dev,
+ pkg-config, libudisks2-qt5-dev, libmount-dev,
  libglib2.0-dev, libpcre3-dev, libnl-genl-3-dev
 Standards-Version: 3.9.8
 Homepage: http://github.com/linuxdeepin/deepin-anything

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel --with dkms

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)" \

override_dh_installinit:
	true

## deepin-anything 6.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.11)
 
 project(deepin-anything)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     FORCE)
 endif(NOT CMAKE_BUILD_TYPE)
 
-message("Build type:"${CMAKE_BUILD_TYPE})
+message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
 
 add_subdirectory("library")
 add_subdirectory("server")

=== src/cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(anything_cli)

# include
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/../library/inc
    ${CMAKE_CURRENT_SOURCE_DIR}/../library/inc/index
    ${CMAKE_CURRENT_SOURCE_DIR}/../kernelmod
)

FILE(GLOB SRC_FILES
    "src/*.c"
)


# Build
add_executable(${PROJECT_NAME} ${SRC_FILES})

target_include_directories(${PROJECT_NAME}
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/inc
)

target_link_libraries(
    ${PROJECT_NAME}
    anything
)

# binary
install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== src/cli/Makefile ===
CFLAGS := -std=gnu99 -Wall -I../library/inc -I../library/inc/index -I../kernelmod -Iinc
LDFLAG := -lpthread -lanything

all: release debug

release: bin/release/anything_cli

bin/release/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../library/bin/release/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -O3 $^ -o $@ ${LDFLAG}

debug: bin/debug/anything_cli

bin/debug/anything_cli: src/*.c
	mkdir -p $(shell dirname $@)
	rm -f $(shell dirname $@)/*.so
	ln -s $(shell realpath ../library/bin/debug/libanything.so) $(shell dirname $@)/libanything.so
	gcc ${CFLAGS} -L$(shell dirname $@) -DIDX_DEBUG -g $^ -o $@ ${LDFLAG}

clean:
	rm -rf bin

.PHONY: all release debug clean

=== src/kernelmod/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 obj-m += vfs_monitor.o
 vfs_monitor-objs := arg_extractor.o event_merge.o event.o module.o \
-		    vfs_kretprobes.o vfs_fsnotify.o vfs_genl.o
+		    vfs_kretprobes.o vfs_fsnotify.o vfs_genl.o vfs_sysfs.o
 ccflags-y := -std=gnu99 -Wall -O3
 cwd := $(shell pwd)

=== src/library/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.11)
 
 project(anything)

=== src/library/Makefile ===
CC := gcc

# Set the default target directory
RELEASE_DIR = bin/release
DEBUG_DIR = bin/debug
EXTERNAL_DIR = ../../3rdparty

ifeq ($(PROJECT_VERSION),)
    PROJECT_VERSION = 1.0.0
endif

# default install dir
ifeq ($(INSTALL_DIR),)
    INSTALL_DIR = /usr/local/lib
endif

SOURCES := \
	$(wildcard src/*.c) \
	$(wildcard src/index/*.c) \
	$(wildcard src/chinese/*.c) \
	$(wildcard $(EXTERNAL_DIR)/fsearch/*.c)

TARGET := libanything.so
SONAME = $(TARGET).0
REALNAME = $(TARGET).$(PROJECT_VERSION)

GLIB_INCL := $(shell pkg-config --cflags glib-2.0)
GLIB_LIB := $(shell pkg-config --libs glib-2.0)

INCLUDE_DIR := -Iinc -Iinc/index -I$(EXTERNAL_DIR)/fsearch ${GLIB_INCL}

CFLAGS := -std=gnu99 -Wall -Wl,--no-undefined -D_GNU_SOURCE ${INCLUDE_DIR} -shared -fPIC -fvisibility=hidden
LDFLAGS := -lpthread -lpcre ${GLIB_LIB} -shared -Wl,-soname,$(REALNAME)

all: release debug

release: $(SOURCES)
	mkdir -p $(RELEASE_DIR)
	$(CC) $(CFLAGS) -O3 $^ $(LDFLAGS) --shared -o $(RELEASE_DIR)/$(REALNAME)
	ln -sf $(REALNAME) $(RELEASE_DIR)/$(TARGET)


debug: $(SOURCES)
	mkdir -p $(DEBUG_DIR)
	$(CC) $(CFLAGS) -g -DIDX_DEBUG $^ $(LDFLAGS) --shared -o $(DEBUG_DIR)/$(REALNAME)
	ln -sf $(REALNAME) $(DEBUG_DIR)/$(TARGET)

install:
	install -m 755 $(RELEASE_DIR)/$(REALNAME) $(INSTALL_DIR)
	ln -sf $(REALNAME) $(INSTALL_DIR)/$(SONAME)
	ln -sf $(SONAME) $(INSTALL_DIR)/$(TARGET)

clean:
	rm -rf bin

.PHONY: all release debug install clean

=== src/server/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 project(deepin-anything-server-lib)
 
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.11)
 
 # Setup the environment
 SET(CMAKE_CXX_STANDARD 17)
@@ -15,5 +15,10 @@
   set(CMAKE_BUILD_TYPE "Release")
 endif(NOT CMAKE_BUILD_TYPE)
 
+# Find Qt version
+find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
+message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
+set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})
+
 add_subdirectory("backend")
 add_subdirectory("app")

=== examples/deepin-anything-monitor/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Kingtous <me@kingtous.cn>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.1)

# 同时生成 一个 exe 和 两个 lib 三个文件
# lib 文件包含 Preload 插件和 MainComponent 插件
# (1) Preload 插件保证程序启动的入口。
# (2) MainCompnent 会在加载完毕自动添加到 Preload 中

# Application
if (NOT CMAKE_BUILD_TYPE STREQUAL "Release")
    set(LIBRARY_OUTPUT_PATH "${CMAKE_CURRENT_SOURCE_DIR}/lib")
    add_definitions(-DPLUGINPATH="${LIBRARY_OUTPUT_PATH}")
endif()

add_subdirectory(main)
add_subdirectory(preloadplugin)
add_subdirectory(maincomponentplugin)

=== src/server/app/CMakeLists.txt ===
--- 
+++ 
@@ -20,14 +20,16 @@
 )
 
 find_package(PkgConfig REQUIRED)
-find_package(Qt5 COMPONENTS Core REQUIRED)
+find_package(Qt${QT_DESIRED_VERSION} COMPONENTS Core REQUIRED)
 
 add_executable(${PROJECT_NAME} ${SRCS})
 
 target_link_libraries(${PROJECT_NAME} PUBLIC
-    Qt5::Core
+    Qt${QT_DESIRED_VERSION}::Core
     deepin-anything-server-lib
 )
 
 # binary
 install(TARGETS ${PROJECT_NAME} DESTINATION bin)
+
+install (FILES deepin-anything-server.service DESTINATION lib/systemd/system)

=== src/server/backend/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.11)
 
 # Version
 if (NOT PROJECT_VERSION)
@@ -23,26 +23,25 @@
 set(LFTManager_XML ${CMAKE_CURRENT_SOURCE_DIR}/dbusservice/com.deepin.anything.xml)
 
 # Setup the environment
-find_package(Qt5 COMPONENTS Core REQUIRED)
-find_package(Qt5 COMPONENTS Concurrent REQUIRED)
-find_package(Qt5 COMPONENTS DBus REQUIRED)
+set(qt_required_components Core DBus Concurrent)
+
+find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
+
 find_package(PkgConfig REQUIRED)
+find_package(PolkitQt${QT_DESIRED_VERSION}-1)
 
 pkg_check_modules(GLIB REQUIRED glib-2.0)
 pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)
 pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)
 
-pkg_check_modules(qt-udisks2 REQUIRED udisks2-qt5 IMPORTED_TARGET)
+pkg_check_modules(qt-udisks2 REQUIRED udisks2-qt${QT_DESIRED_VERSION} IMPORTED_TARGET)
 
-# generate dbus interface
-# DBus: LFTManager
-# qt5_generate_dbus_interface(
-#     lftmanager.h
-#     ${DeviceManager_XML}
-#     OPTIONS -M -S
-# )
-qt5_add_dbus_adaptor(SRCS ${LFTManager_XML}
-    lftmanager.h LFTManager anything_adaptor)
+# 生成 D-Bus 适配器
+if (QT_DESIRED_VERSION MATCHES 6)
+    qt_add_dbus_adaptor(ADAPTORS ${LFTManager_XML} lftmanager.h LFTManager anything_adaptor)
+else()
+    qt5_add_dbus_adaptor(ADAPTORS ${LFTManager_XML} lftmanager.h LFTManager anything_adaptor)
+endif()
 
 # include
 include_directories(
@@ -66,7 +65,7 @@
 add_library(${PROJECT_NAME} SHARED
     ${PRIVATE_INCLUDES}
     ${SERVER_SRCS}
-    ${SRCS}
+    ${ADAPTORS}
 )
 
 set_target_properties(
@@ -76,14 +75,15 @@
 )
 
 target_link_libraries(${PROJECT_NAME} PUBLIC
-    Qt5::Core
-    Qt5::Concurrent
-    Qt5::DBus
+    Qt${QT_DESIRED_VERSION}::Core
+    Qt${QT_DESIRED_VERSION}::Concurrent
+    Qt${QT_DESIRED_VERSION}::DBus
     PkgConfig::qt-udisks2
     anything
     ${MOUNT_LIBRARIES}
     ${GLIB_LIBRARIES}
     ${GNL_LIBRARIES}
+    PolkitQt${QT_DESIRED_VERSION}-1::Agent
 )
 
 target_include_directories(${PROJECT_NAME} PUBLIC
@@ -103,6 +103,9 @@
 FILE (GLOB DBUS_CONFIG_INSTALL
     "dbusservice/com.deepin.anything.conf"
 )
+FILE (GLOB DBUS_POLICY_INSTALL
+    "dbusservice/com.deepin.anything.policy"
+)
 
 include(GNUInstallDirs)
 
@@ -115,6 +118,9 @@
 install (FILES ${DBUS_CONFIG_INSTALL}
     DESTINATION /etc/dbus-1/system.d
 )
+install (FILES ${DBUS_POLICY_INSTALL}
+    DESTINATION share/polkit-1/actions
+)
 
 install_targets ("/${CMAKE_INSTALL_LIBDIR}" ${PROJECT_NAME})

=== examples/deepin-anything-monitor/src/main/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Kingtous <me@kingtous.cn>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.1)

set(APP_BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(APP_NAME ${CMAKE_PROJECT_NAME})
add_definitions(-DAPP_NAME="${APP_NAME}")

###! main目录创建出二进制可执行文件，但启动方式由 DAppLoader
###! 中提供, 请不要在 main 中实现额外内容，请将需要实现的部分
###! 移动到 preload 插件和 maincomponent 插件中。

# Set sources
set(SRC
    main.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)

# Add EXE
add_executable(${APP_NAME} ${SRC})

# 由于 EXE 只是作为启动程序加载 LIB 使用，一般来说，只需链接 ${LIB_NAME} 既可。
target_link_libraries(${APP_NAME}
    Qt5::Quick
    ${DtkDeclarative_LIBRARIES}
    )

set_target_properties(${APP_NAME} PROPERTIES INSTALL_RPATH ${DTK_QML_APP_PLUGIN_PATH})
install(TARGETS ${APP_NAME} DESTINATION ${APP_BIN_INSTALL_DIR})
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../../${CMAKE_PROJECT_NAME}.desktop" DESTINATION share/applications)

=== debian/changelog ===
deepin-anything (6.2.6) unstable; urgency=medium

  * New version 6.2.6
  * Fix search fail with Qt6.

 -- re2zero <yangwu@uniontech.com>  Thu, 03 Apr 2025 12:36:59 +0800

deepin-anything (6.2.5) unstable; urgency=medium

  * New version 6.2.5
  * Merge Qt5 and Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Thu, 27 Mar 2025 13:25:42 +0800

deepin-anything (6.2.4) unstable; urgency=medium

  * Fix search fail in immutable system

 -- wangrong <wangrong@uniontech.com>  Thu, 20 Mar 2025 15:52:31 +0800

deepin-anything (6.2.3) unstable; urgency=medium

  * Fix search fail for invalid path.

 -- wangrong <wangrong@uniontech.com>  Thu, 06 Mar 2025 21:06:39 +0800

deepin-anything (6.2.2) unstable; urgency=medium

  * New version 6.2.2.
  * Fix log files take up a lot of space.
  * Add support for s360x, ppc64le and riscv.
  * Optimize recoginizing ARM.

 -- wangrong <wangrong@uniontech.com>  Tue, 07 Jan 2025 20:41:36 +0800

deepin-anything (6.2.1) unstable; urgency=medium

  * adapt kernel module for LOONGARCH architecture.

 -- wangrong <wangrong@uniontech.com>  Wed, 25 Dec 2024 09:19:04 +0800

deepin-anything (6.2.0) unstable; urgency=medium

  * New version 6.2.0

 -- wangrong <wangrong@uniontech.com>  Sat, 30 Nov 2024 15:07:10 +0800

deepin-anything (6.1.9) unstable; urgency=medium

  * update log.

 -- Deepin Package Builder <packages@deepin.com>  Fri, 17 May 2024 10:32:00 +0800

deepin-anything (6.1.8) unstable; urgency=medium

  * fix server core dump on restart.

 -- Deepin Package Builder <packages@deepin.com>  Thu, 07 Mar 2024 13:27:30 +0800

deepin-anything (6.1.7) unstable; urgency=medium

  * update version.

 -- Deepin Package Builder <packages@deepin.com>  Sun, 18 Feb 2024 17:13:26 +0800

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,16 @@
 Maintainer: Deepin Package Builder <packages@deepin.com>
 Build-Depends:
  cmake,
- debhelper (>= 9), dh-dkms | dkms, qtbase5-dev,
- pkg-config, libudisks2-qt5-dev, libmount-dev,
- libglib2.0-dev, libpcre3-dev, libnl-genl-3-dev
+ debhelper (>= 11),
+ pkg-config,
+ dh-dkms | dkms,
+ qt6-base-dev | qtbase5-dev,
+ libudisks2-qt6-dev | libudisks2-qt5-dev,
+ libpolkit-qt6-1-dev | libpolkit-qt5-1-dev,
+ libmount-dev,
+ libglib2.0-dev,
+ libpcre3-dev,
+ libnl-genl-3-dev,
 Standards-Version: 3.9.8
 Homepage: http://github.com/linuxdeepin/deepin-anything

=== examples/deepin-anything-monitor/debian/control ===
Source: deepin-anything-monitor
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 deepin-anything-dev (>= 6.0.2),
 debhelper (>= 9),
 cmake,
 pkg-config,
 qtdeclarative5-dev,
 libdtkdeclarative-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-anything-monitor
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A vfs monitor based on deepin-anything module.
 A realtime vfs event monitor based on deepin-anything module.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

%:
	dh $@ --parallel --with dkms,systemd

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)" \
	-DQT_DIR=$(QT_DIR)

override_dh_installinit:
	true

=== examples/deepin-anything-monitor/debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

ifneq (,$(wildcard .git/config))
	CONFIG_VERSION=
else
VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) VERSION=$(CONFIG_VERSION)

## deepin-anything 7.0.14

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,10 +5,15 @@
     FORCE)
 endif(NOT CMAKE_BUILD_TYPE)
 
-message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
+message("Build type:" ${CMAKE_BUILD_TYPE})
 
-add_subdirectory("library")
+# AddressSanitizer only:
+# add_compile_options(-fsanitize=address -g)
+# add_link_options(-fsanitize=address)
+# Or ThreadSanitizer only:
+# add_compile_options(-fsanitize=thread -g)
+# add_link_options(-fsanitize=thread)
+
 add_subdirectory("server")
 add_subdirectory("kernelmod")
-
-# add_subdirectory("cli")
+add_subdirectory("searcher")

=== src/kernelmod/CMakeLists.txt ===
--- 
+++ 
@@ -53,10 +53,10 @@
 message("CMAKE_CURRENT_BINARY_DIR:" ${CMAKE_CURRENT_BINARY_DIR})
 
  # Install the DKMS file into debian dir
- install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-anything-dkms.dkms DESTINATION ../..)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-anything-dkms.dkms DESTINATION ../..)
 
  # Install all source files
- install(FILES ${SRC_FILES} DESTINATION ${INSTALL_DIR})
+install(FILES ${SRC_FILES} DESTINATION ${INSTALL_DIR})
 
   # Install the module conf file
 install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/anything.conf DESTINATION /usr/lib/modules-load.d)

=== src/kernelmod/Makefile ===
--- 
+++ 
@@ -11,4 +11,3 @@
 
 clean:
 	make -C ${kdir} M=$(cwd) clean
-

=== src/searcher/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(deepin-anything-searcher)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find required packages
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(LUCENE REQUIRED liblucene++)
pkg_check_modules(LUCENE_CONTRIB REQUIRED liblucene++-contrib)

# Add executable
add_executable(deepin-anything-searcher
    main.cpp
    searcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chineseanalyzer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chinesetokenizer.cpp
)

# Include directories
target_include_directories(deepin-anything-searcher PRIVATE
    ${GLIB_INCLUDE_DIRS}
    ${LUCENE_INCLUDE_DIRS}
    ${LUCENE_CONTRIB_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/include
)

# Link libraries
target_link_libraries(deepin-anything-searcher
    ${GLIB_LIBRARIES}
    ${LUCENE_LIBRARIES}
    ${LUCENE_CONTRIB_LIBRARIES}
)

# Install
install(TARGETS deepin-anything-searcher
    RUNTIME DESTINATION bin
)

=== src/server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# ---------------------------------------------------------------------------------------
# Start deepin-anything-daemon project
# ---------------------------------------------------------------------------------------
project(
    deepin-anything-daemon
    VERSION 1.0.0
    DESCRIPTION "A file search engine"
    LANGUAGES CXX
)

# Find the dependencies
find_package(QT NAMES Qt6 Qt5 CONFIG REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} CONFIG REQUIRED Core)
find_package(PkgConfig REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)
find_package(spdlog REQUIRED)
pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)
pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)
pkg_check_modules(LUCENE REQUIRED liblucene++)
pkg_check_modules(LUCENE_CONTRIB REQUIRED liblucene++-contrib)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)

# Found all source files
file(GLOB_RECURSE SOURCE_FILES "${PROJECT_SOURCE_DIR}/src/*.cpp" "${PROJECT_SOURCE_DIR}/src/*.c")
list(LENGTH SOURCE_FILES SRC_FILES_SIZE)
message(STATUS "Found ${SRC_FILES_SIZE} source files of deepin-anything-daemon")
foreach(source_file ${SOURCE_FILES})
    message(STATUS "  ${source_file}")
endforeach()

# Define a shared library
add_executable(${PROJECT_NAME})

target_sources(${PROJECT_NAME} PRIVATE ${SOURCE_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../kernelmod>
    # $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    ${LUCENE_INCLUDE_DIRS}
    ${GNL_INCLUDE_DIRS}
    ${MOUNT_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PUBLIC
    ${LUCENE_LIBRARIES}
    ${LUCENE_CONTRIB_LIBRARIES}
    ${GNL_LIBRARIES}
    ${MOUNT_LIBRARIES}
    ${Boost_LIBRARIES}
    pthread
    stdc++fs
    spdlog::spdlog
    ${GLIB_LIBRARIES}
    ${GIO_LIBRARIES}
    Qt${QT_VERSION_MAJOR}::Core
)

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Werror -Wextra)
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)

configure_file ("${PROJECT_NAME}.pc.in" "${PROJECT_NAME}.pc" @ONLY)
install(TARGETS ${PROJECT_NAME}
    COMPONENT linapp
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    DESTINATION lib
)

install(PROGRAMS deepin-anything-server DESTINATION bin)
install(FILES deepin-anything-daemon.service DESTINATION lib/systemd/user)
install(FILES deepin-anything-server.service DESTINATION lib/systemd/system)

# Install dconfig meta file
install(FILES ${CMAKE_SOURCE_DIR}/assets/org.deepin.anything.json DESTINATION share/dsg/configs/org.deepin.anything)

=== debian/changelog ===
deepin-anything (7.0.14) unstable; urgency=medium

  * feat: Clean up event handling and logging

 -- wangrong <wangrong@uniontech.com>  Mon, 12 May 2025 14:21:12 +0800

deepin-anything (7.0.13) unstable; urgency=medium

  * feat: Add thread pool size config from env
  * fix: Fix set index status to monitoring too early
  * refactor: Remove file_record structure and related functionality
  * feat: Refactor event handler to use shared configuration
  * feat: Add deepin-anything-searcher utils
  * refactor: Removing DBus-related code
  * refactor: Simplify file index management methods
  * refactor: Standardize namespace naming and enhance string handling
  * refactor: Enhance index directory management in event handler
  * feat: Support obtaining configuration via dconfig
  * feat: Implement configuration change notification
  * feat: Introduce log level configuration

 -- wangrong <wangrong@uniontech.com>  Wed, 07 May 2025 16:50:03 +0800

deepin-anything (7.0.12) unstable; urgency=medium

  * fix: Fail to search after manual partitioning
  * fix: Fix crash after turning off protection

 -- wangrong <wangrong@uniontech.com>  Sun, 27 Apr 2025 14:30:41 +0800

deepin-anything (7.0.11) unstable; urgency=medium

  * feat: Enhance index management with status tracking
  * feat: Support determine home directory dynamically

 -- wangrong <wangrong@uniontech.com>  Thu, 24 Apr 2025 21:31:01 +0800

deepin-anything (7.0.10) unstable; urgency=medium

  * feat: Filter out blacklisted data when refreshing the index

 -- wangrong <wangrong@uniontech.com>  Tue, 22 Apr 2025 19:53:58 +0800

deepin-anything (7.0.9) unstable; urgency=medium

  * chore: Update license information
  * refactor: Simplify file type mapping
  * fix: Change DBus connection to sessionBus
  * refactor: Support indexing hidden files
  * feat: Add is_hidden field
  * feat: Using the New Analyzer
  * feat: Support index directory blacklist
  * feat: Implement index version management
  * feat: Use new home directory location
  * feat: Implement kernel module alive check

 -- wangrong <wangrong@uniontech.com>  Mon, 21 Apr 2025 17:04:58 +0800

deepin-anything (7.0.8) unstable; urgency=medium

  * chore: Adjust build and packaging
  * chore: Run the daemon as user service
  * refactor: Adjust the matching mechanism for search keyword
  * feat: Add fields for the index
  * feat: Improve performance by saving indexes to tmpfs
  * refactor: Enhance get_home_directory function and add event filters
  * fix: Handle corrupted index during initialization
  * feat: Add pinyin field to search results and modify pinyin conversion logic
  * feat: Add post-install script for deepin-anything-server

 -- wangrong <wangrong@uniontech.com>  Mon, 31 Mar 2025 13:16:50 +0800

deepin-anything (7.0.7) unstable; urgency=medium

  * Major update with a complete refactor and version upgrade.
  * Fixed high CPU usage issues.
  * Enhanced real-time updates for improved responsiveness.
  * Improved index consistency to ensure more reliable performance.
  * Fix missing handling of subdirectories and subfiles when updating/removing a directory
  * Other bug fixes and optimizations.

 -- Deepin Package Builder <packages@deepin.com>  Tue, 19 Nov 2024 10:32:00 +0800

=== debian/control ===
Source: deepin-anything
Section: admin
Priority: optional
Maintainer: Deepin Package Builder <packages@deepin.com>
Build-Depends:
  cmake,
  debhelper (>= 10),
  dh-dkms | dkms,
  qt6-base-dev | qtbase5-dev,
  pkg-config,
  libnl-genl-3-dev,
  liblucene++-dev,
  libmount-dev,
  libboost-filesystem-dev,
  libspdlog-dev,
  libglib2.0-dev,
Standards-Version: 3.9.8
Homepage: http://github.com/linuxdeepin/deepin-anything

Package: deepin-anything-dkms
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
Description: anything module
 anything kernel module package

Package: deepin-anything-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, deepin-anything-dkms
Description: Deepin Anything server package
 This is the server part of Deepin Anything, which includes core functionality for the application.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel --with dkms,systemd

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)"

override_dh_installinit:
	true

override_dh_auto_clean:
